


Public Class MClass

    <CommandMethod("HelloWorld")> _
    Public Sub MyMethod()

        ' Some variable definitions
        Dim activeDoc As Document
        Dim BTR As BlockTableRecord

        ' Store a reference to the currently active document (to make the next two lines of code  shorter)
        activeDoc = Application.DocumentManager.MdiActiveDocument

        ' Start a transaction to edit the DWG database
        Using trans As Transaction = activeDoc.TransactionManager.StartTransaction()

            ' Open BlockTableRecord of currently active space ready to add entity. 
            ' (This will be ModelSpace if you've not switched to a layout, otherwise PaperSpace).
            BTR = trans.GetObject(activeDoc.Database.CurrentSpaceId, Autodesk.AutoCAD.DatabaseServices.OpenMode.ForWrite)

            ' Create a new MText entity and set its text
            Dim txt As MText = New MText
            txt.Contents = "Hello World from VB.NET!"

            ' Add the MText to ModelSpace
            BTR.AppendEntity(txt)
            txt.SetDatabaseDefaults()

            ' Add the Mtext to the transaction
            trans.AddNewlyCreatedDBObject(txt, True)

            ' Commit transaction so changes persist in the DWG Database. 
            trans.Commit()

        End Using

    End Sub

End Class

