


Public Class SGP_Commands

    ' Define command 'Iterate'
    <CommandMethod("ITERATE")> _
 Public Sub Asdkcmd1()
        ' Type your code here

        Dim activeDoc As Document = Application.DocumentManager.MdiActiveDocument
        Dim db As Database = activeDoc.Database

        'Start a transaction so we can access database resident objects
        Using trans As Transaction = db.TransactionManager.StartTransaction()

            'Get the current space - could be model or paperspace
            Dim BTR As BlockTableRecord = trans.GetObject(db.CurrentSpaceId, Autodesk.AutoCAD.DatabaseServices.OpenMode.ForRead)

            'Iterate current space (we iterate through the ObjectIds of the entities)
            For Each id As ObjectId In BTR

                'Open each entity in turn using its ObjectId
                Dim ent As Entity = trans.GetObject(id, Autodesk.AutoCAD.DatabaseServices.OpenMode.ForRead)

                'Is it MText
                If TypeOf ent Is MText Then

                    'Cast to MText 
                    Dim txt As MText = ent
                    'Display text string in alett dialog
                    Application.ShowAlertDialog("MText entity found." & vbLf & vbLf & "Text is: " & txt.Text)

                End If

            Next
            'Note we don't commit the transaction, as we're not editing anything
        End Using

    End Sub




    <CommandMethod("HelloWorld")> _
 Public Sub MyMethod()

        ' Some variable definitions
        Dim activeDoc As Document
        Dim BTR As BlockTableRecord

        ' Store a reference to the currently active document (to make the next two lines of code  shorter)
        activeDoc = Application.DocumentManager.MdiActiveDocument

        ' Start a transaction to edit the DWG database
        Using trans As Transaction = activeDoc.TransactionManager.StartTransaction()

            ' Open BlockTableRecord of currently active space ready to add entity. 
            ' (This will be ModelSpace if you've not switched to a layout, otherwise PaperSpace).
            BTR = trans.GetObject(activeDoc.Database.CurrentSpaceId, Autodesk.AutoCAD.DatabaseServices.OpenMode.ForWrite)

            ' Create a new MText entity 
            Dim txt As MText = New MText

            'Prompt for some text to customize the string we give the MText to display
            Dim txtOpts As New PromptStringOptions(vbLf & "Who should I say hello to?")
            txtOpts.DefaultValue = "World"
            txtOpts.AllowSpaces = True

            Dim txtRes As PromptResult = activeDoc.Editor.GetString(txtOpts)

            If txtRes.Status = PromptStatus.Cancel Then

                'If use pressed cancel, then they didn't want text inserted
                Exit Sub

            ElseIf txtRes.Status = PromptStatus.OK Then

                'If everything was ok, then we add the text entered by user into the MText string
                txt.Contents = "Hello " & txtRes.StringResult & " from VB.NET!"

            Else

                'If user did anything else, then we assume they wanted the default text
                txt.Contents = "Hello " & txtOpts.DefaultValue & " from VB.NET!"

            End If

            Dim ptOpts As New PromptPointOptions(vbLf & "Where do you want to place the text?")
            ptOpts.Keywords.Add("Origin")
            ptOpts.Keywords.Add("Random")

            Dim ptRes As PromptPointResult = activeDoc.Editor.GetPoint(ptOpts)

            Dim pt As Point3d
            If ptRes.Status = PromptStatus.Cancel Then

                'If user hit cancel we assume they wanted to cancel the whole command
                Exit Sub

            ElseIf ptRes.Status = PromptStatus.OK Then

                'If the user picked or typed in a point, then we just use that
                pt = ptRes.Value

            ElseIf ptRes.Status = PromptStatus.Keyword Then

                'If its a keyword we need to find out which one
                If ptRes.StringResult = "Origin" Then
                    pt = New Point3d(0, 0, 0)
                Else
                    'If its a keyword and not [Origin], then it must be [Random]
                    'I lied about the insertion point being random :-)
                    pt = New Point3d(1, 1, 0)
                End If

            Else

                'If anything else, we just insert the MText at (0,0,0)
                pt = New Point3d(0, 0, 0)

            End If

            'Create transformation matrix to translate text to selected insertion point
            '(Obviously this transformation does nothing if we selected (0,0,0))
            Dim mat As Matrix3d = Matrix3d.Displacement(pt.GetAsVector)

            'Move the text
            txt.TransformBy(mat)

            ' Add the MText to ModelSpace
            BTR.AppendEntity(txt)
            txt.SetDatabaseDefaults()

            ' Add the Mtext to the transaction
            trans.AddNewlyCreatedDBObject(txt, True)

            ' Commit transaction so changes persist in the DWG Database. 
            trans.Commit()

        End Using

    End Sub

End Class


